Imports System.Drawing
Imports System.Drawing.Imaging
Partial Class _Default
    Inherits System.Web.UI.Page

#Region "variaveis"
    ' declarao de variveis
    Private mImagem As Bitmap
    Private g As Graphics
    Private vendas() As Integer = {100, 60, 250, 80, 120, 150}
    Private meses() As String = {"Jan", "Fev", "Mar", "Abr", "Mai", "Jun"}
    Private mBrushes(6) As Brush
#End Region

#Region "metodos"
    'inicia o bitmap, o contexto grfico e pens para desenho
    Private Sub inicializaAmbienteGrafico()
        Try
            ' Cria um bitmap na memoria onde vamos desenhar a imagem
            ' O BitMap possui uma largura de 300 pixels e altura de 200 pixels
            mImagem = New Bitmap(700, 400, PixelFormat.Format32bppRgb)

            ' Obtem o conexto grfico para o  bitmap.
            g = Graphics.FromImage(mImagem)

            '   Cria as brushes para desenho
            criaBrushes()
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    '   Ntodo para criar as brushes para cores especificas
    Private Sub criaBrushes()
        Try
            mBrushes(0) = New SolidBrush(Color.Red)
            mBrushes(1) = New SolidBrush(Color.Blue)
            mBrushes(2) = New SolidBrush(Color.Yellow)
            mBrushes(3) = New SolidBrush(Color.Green)
            mBrushes(4) = New SolidBrush(Color.Beige)
            mBrushes(5) = New SolidBrush(Color.Cyan)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    '   Desenha o grafico de barras
    Private Sub graficoBarras(ByVal g As Graphics)
        Try
            '  declara variaveis
            Dim i As Integer
            Dim xInterval As Integer = 100
            Dim width As Integer = 90
            Dim height As Integer
            Dim blackBrush As New SolidBrush(Color.Black)

            For i = 0 To vendas.Length - 1
                '  divide por 10000 para ajustar o grafico para a altura do bitmap
                height = vendas(i)

                '   Desenha o grafico de barras usando as cores
                g.FillRectangle(mBrushes(i), xInterval * i + 50, 280 - height, width, height)

                '   usa as etiquetas para o grafico
                g.DrawString(meses(i), New Font("Verdana", 12, FontStyle.Bold), Brushes.Black, xInterval * i + 50 + (width / 3), 280 - height - 25)

                '   Desenha a escala
                g.DrawString(height, New Font("Verdana", 8, FontStyle.Bold), Brushes.Black, 0, 280 - height)

                '   Desenha os eixos
                g.DrawLine(Pens.Brown, 40, 10, 40, 390)         '   eixo- y
                g.DrawLine(Pens.Brown, 20, 280, 690, 280)       '   eixo-x
            Next
        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    '   desenha o grafico de pizza
    Private Sub graficoPizza(ByVal g As Graphics)
        Try
            '   declara as variaveis
            Dim i As Integer
            Dim total As Integer
            Dim percentage As Double
            Dim angleSoFar As Double = 0.0

            '   Calcula o total
            For i = 0 To vendas.Length - 1
                total += vendas(i)
            Next

            '   Desenha o grafico de barras
            For i = 0 To vendas.Length - 1
                percentage = vendas(i) / total * 360

                g.FillPie(mBrushes(i), 25, 25, 250, 250, CInt(angleSoFar), CInt(percentage))

                angleSoFar += percentage

                '   Desenha a legenda
                g.FillRectangle(mBrushes(i), 350, 25 + (i * 50), 25, 25)

                '   Etiqueta dos meses
                g.DrawString("Mes " & meses(i), New Font("Verdana", 8, FontStyle.Bold), Brushes.Brown, 390, 25 + (i * 50) + 10)
            Next
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
#End Region

#Region "Eventos"
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' Inicia o ambiente
        inicializaAmbienteGrafico()
    End Sub
    Protected Sub btnGBarras_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnGBarras.Click
        Try
            ' Define a cor de fundo
            g.Clear(Color.White)

            'desenha o grafico de barras
            graficoBarras(g)

            ' Renderiza a imagem para a saida HTML stream
            mImagem.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
    Protected Sub btnGPizza_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnGPizza.Click
        Try
            ' Defina a cor de fundo 
            g.Clear(Color.Gold)

            '   desenha o grafico
            graficoPizza(g)

            ' Renderiza a imagem para a saida HTML stream
            mImagem.Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg)
        Catch ex As Exception
            Throw ex
        End Try
    End Sub
#End Region
End Class
